import java.io.FileInputStream;
import java.io.InputStream;
import java.util.Hashtable;
import com.ibm.xml.parser.ElementHandler;
import com.ibm.xml.parser.Parser;
import com.ibm.xml.parser.TXElement;

/**
 *       MakeEltTblEltHandler.java
 **/
// This class is XML4J specific.
public class MakeEltTblEltHandler implements ElementHandler {

    Hashtable hash = new Hashtable();
    String key = null;
    
                                      // ElementHandler
    public TXElement handleElement(TXElement el) { 
        String name = el.getNodeName();
        // Extract value of tag "key"
        if (name.equals("key")) {
            this.key = el.getText();
        // Extract value of tag "value" and store the pair into HashTable
        } else if (name.equals("value") && this.key != null) {
            this.hash.put(this.key, el.getText());
            this.key = null;
        }
        return el;
    }
    
    static public void main(String[] argv) {
        if (argv.length != 1) {
            System.err.println("Missing filename.");
            System.exit(1);
        }
        try {
            InputStream is = new FileInputStream(argv[0]);
            Parser parser = new Parser(argv[0]);

            // Create and register ElementHandler
            MakeEltTblEltHandler handler = new MakeEltTblEltHandler();
            parser.addElementHandler(handler, "key");
            parser.addElementHandler(handler, "value");

            // Start parsing
            parser.readStream(is);

            // Error check
            if (parser.getNumberOfErrors() > 0) {
                System.exit(1);
            }

            // Display HashTable
            System.out.println(handler.hash);

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
